/* 
   $Id: sgaddr_list.c,v 1.7 2001/12/25 10:43:56 sho Exp $

   Copyright (C) 2001,2002 AXE,Inc. <sg@axe-inc.co.jp>

   This file is part of sgaddr.

   sgaddr is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   sgaddr is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with sgaddr; see the file COPYING.   If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include "sgaddr.h"

extern  int                array_tail, current_num;
extern  struct person_data *array[MAX_PERSONS]; 
extern  int                kana_array[12]; 

struct person_data *
create_person_data()
{
  struct person_data *tmp = NULL;

  tmp = (struct person_data *) calloc(1, sizeof(struct person_data));
  if(tmp != NULL) return tmp;

  return NULL;
}

void
insert_person_data(struct person_data *data)
{
  current_num = array_tail;
  array[array_tail++] = data;
}

void
remove_person_data(int num)
{
  if(array[num]->name)  free((void *)array[num]->name);
  if(array[num]->ruby)  free((void *)array[num]->ruby);
  if(array[num]->home)  free((void *)array[num]->home);  
  if(array[num]->phone) free((void *)array[num]->phone); 
  if(array[num]->email) free((void *)array[num]->email);

  if(array[num]) free((void *)array[num]);
  
  if(num == (array_tail - 1))
    array[num] = NULL;
  else
    array[num] = array[array_tail - 1];

  array_tail--;
  if(array_tail < 0) array_tail = 0;
}

int
comp(struct person_data **a, struct person_data **b)
{
  if(!(*a)->ruby && (*b)->ruby)         return -1;
  else if((*a)->ruby && !(*b)->ruby)    return 1;
  else if(!(*a)->ruby && !(*b)->ruby)   return 0;

  return strcmp((*a)->ruby, (*b)->ruby);
}

void get_initial_ja()
{
  int            i;
  unsigned short code;
  
  for(i = 0; i < array_tail; i++){
    if(array[i]->ruby){
      code  = array[i]->ruby[0] << 8;
      code |= array[i]->ruby[1] & 0xff;
      
      if(code >= 0xa4a1 && code <=0xa4aa){
	if(kana_array[0] < 0) kana_array[0] = i;
      }else if(code >= 0xa4ab && code <=0xa4b4){
	if(kana_array[1] < 0) kana_array[1] = i;
      }else if(code >= 0xa4b5 && code <=0xa4be){
	if(kana_array[2] < 0) kana_array[2] = i;
      }else if(code >= 0xa4bf && code <=0xa4c9){
	if(kana_array[3] < 0) kana_array[3] = i;
      }else if(code >= 0xa4ca && code <=0xa4ce){
	if(kana_array[4] < 0) kana_array[4] = i;
      }else if(code >= 0xa4cf && code <=0xa4dd){
	if(kana_array[5] < 0) kana_array[5] = i;
      }else if(code >= 0xa4de && code <=0xa4e3){
	if(kana_array[6] < 0) kana_array[6] = i;
      }else if(code >= 0xa4e4 && code <=0xa4e7){
	if(kana_array[7] < 0) kana_array[7] = i;
      }else if(code >= 0xa4e9 && code <=0xa4ee){
	if(kana_array[8] < 0) kana_array[8] = i;
      }else if(code >= 0xa4ef && code <=0xa4f3){
	if(kana_array[9] < 0) kana_array[9] = i;
      }else if(isalpha((code >> 8) & 0xff)){
	if(kana_array[10] < 0) kana_array[10] = i;
      }else if(isdigit((code >> 8) & 0xff)){
	if(kana_array[11] < 0) kana_array[11] = i;
      }
    }
  }
}

void get_initial()
{
  int            i;
  unsigned char  code;
  
  for(i = 0; i < array_tail; i++){
    if(array[i]->ruby){
      code = tolower(array[i]->ruby[0] & 0xff);
      
      if(code >= 'a' && code <= 'c'){
	if(kana_array[0] < 0) kana_array[0] = i;
      }else if(code >= 'd' && code <= 'f'){
	if(kana_array[1] < 0) kana_array[1] = i;
      }else if(code >= 'g' && code <= 'i'){
	if(kana_array[2] < 0) kana_array[2] = i;
      }else if(code >= 'j' && code <= 'l'){
	if(kana_array[3] < 0) kana_array[3] = i;
      }else if(code >= 'm' && code <= 'o'){
	if(kana_array[4] < 0) kana_array[4] = i;
      }else if(code >= 'p' && code <= 's'){
	if(kana_array[5] < 0) kana_array[5] = i;
      }else if(code >= 't' && code <= 'v'){
	if(kana_array[6] < 0) kana_array[6] = i;
      }else if(code >= 'w' && code <= 'z'){
	if(kana_array[7] < 0) kana_array[7] = i;
      }else if(isdigit(code)){
	if(kana_array[11] < 0) kana_array[11] = i;
      }
    }
  }
}

void
sort_by_ruby()
{
  int i;
  struct person_data *bak;
  char *locale = NULL;
 
  bak = array[current_num];
   
  qsort((void *)array, array_tail, sizeof(struct person_data *), (void *)comp);

  for(i = 0; i < 12; i++)
    kana_array[i] = -1;
 
  for(i=0; i<array_tail; i++){
    if(array[i] == bak){
      current_num = i;
      break;
    }
  }
  
  locale = getenv("LC_MESSAGES");
  if(locale == NULL) locale = getenv("LANG");

  if(locale != NULL && sgaddr_locale_ja_chk(locale))
    get_initial_ja();
  else
    get_initial();
}

#ifdef OLD_STYLE
void write_string_to_file(FILE *fp, char *str)
{
  if(!str) return;

  while(*str != '\0'){
    switch(*str){
    case '\n':
      fputc('\\', fp);
      fputc('n', fp);
      break;

    case '\\':
    case '\t':
    case '{':
    case '}':
    case ':':
    case ';':
    case ' ':
      fputc('\\', fp);

    default:
      fputc(*str, fp);
      break;
    }
    str++;
  }

}
#endif

void save_person_data()
{
  FILE               *fp = NULL;
  struct person_data *tmp;
  int i;
  char               *home;
  char               fn[4096];

  if ((home = getenv("HOME")) != NULL) {
    sprintf(fn,"%s/sgaddrbook",home);
  } else {
    sprintf(fn,"sgaddrbook");
  }

  fp = fopen(fn, "w"); 
  
  if(fp == NULL){
    fprintf(stderr, "I can't open  address book file:%s.\n",fn);
    return;
  }

  chmod(fn, S_IRUSR|S_IWUSR);

#ifdef OLD_FORMAT
  for(i = 0; i < array_tail; i++){
    tmp = array[i];
    fprintf(fp, "{\n");

    if(tmp->name){
      fprintf(fp, "\tName:");
      write_string_to_file(fp, tmp->name);
      fprintf(fp, ";\n");
    }

    if(tmp->ruby){
      fprintf(fp, "\tRuby:");
      write_string_to_file(fp, tmp->ruby);
      fprintf(fp, ";\n");
    }

    if(tmp->home){
      fprintf(fp, "\tHome:"); 
      write_string_to_file(fp, tmp->home);
      fprintf(fp, ";\n");
    }

    if(tmp->phone){
      fprintf(fp, "\tPhone:");
      write_string_to_file(fp, tmp->phone);
      fprintf(fp, ";\n");
    }

    if(tmp->mobile){
      fprintf(fp, "\tMobile:"); 
      write_string_to_file(fp, tmp->mobile);
      fprintf(fp, ";\n");
    }

    if(tmp->email){
      fprintf(fp, "\tEmail:");
      write_string_to_file(fp, tmp->email);
      fprintf(fp, ";\n");
    }

    if(tmp->etc){
      fprintf(fp, "\tEtc:");
      write_string_to_file(fp, tmp->etc);
      fprintf(fp, ";\n");
    }

    fprintf(fp, "}\n\n");
  }
#else
  for(i = 0; i < array_tail; i++){
    tmp = array[i];
    fprintf(fp, "(");

    fprintf(fp, "\"");
    if(tmp->name) fprintf(fp, "%s", tmp->name);
    fprintf(fp, "\"");

    fprintf(fp, " \"");
    if(tmp->ruby) fprintf(fp, "%s", tmp->ruby);
    fprintf(fp, "\"");

    fprintf(fp, " \"");
    if(tmp->home) fprintf(fp, "%s", tmp->home);
    fprintf(fp, "\"");

    fprintf(fp, " \"");
    if(tmp->phone) fprintf(fp, "%s", tmp->phone);
    fprintf(fp, "\"");

    fprintf(fp, " \"");
    if(tmp->mobile) fprintf(fp, "%s", tmp->mobile);
    fprintf(fp, "\"");

    fprintf(fp, " \"");
    if(tmp->email) fprintf(fp, "%s", tmp->email);
    fprintf(fp, "\"");

    fprintf(fp, " \"");
    if(tmp->etc) fprintf(fp, "%s", tmp->etc);
    fprintf(fp, "\"");

    fprintf(fp, ")\n");
  }

#endif

  fclose(fp);
}

void load_person_data()
{
  FILE               *fp = NULL;
  struct person_data *tmp = NULL;
  char               str[4096];
  char               *home;
  char               fn[4096];

#ifdef OLD_FORMAT
  char               *buf, *p, *q;
  int                size = 0, state = 0;
#else
  char *s;
  int  i,c;
#endif

  if ((home = getenv("HOME")) != NULL) {
    sprintf(fn,"%s/sgaddrbook",home);
  } else {
    sprintf(fn,"sgaddrbook");
  }
  fp = fopen(fn, "r");
  
  if(fp == NULL){
    fprintf(stderr, "I can't open address book file:%s.\n"
      "I will try to create one later.\n",fn);
    return;
  }

#ifdef OLD_FORMAT
  fseek(fp, 0, SEEK_END);
  size = ftell(fp);

  if(size == 0)    return;

  buf = (char *) malloc(sizeof(char) * (size + 1));
  fseek(fp, 0, SEEK_SET);
  fread(buf, size, 1, fp);
  buf[size] = '\0';
  
  p = buf, q = str;
  bzero(str, 256);

  while(*p != '\0'){
    switch(*p){
    case '{':
      tmp = create_person_data();
      break;
      
    case '}':
      insert_person_data(tmp);
      break;

    case ':':
      if(strcmp(str, "Name") == 0)       state = ADDR_NAME;
      else if(strcmp(str, "Ruby") == 0)  state = ADDR_RUBY; 
      else if(strcmp(str, "Home") == 0)  state = ADDR_HOME; 
      else if(strcmp(str, "Phone") == 0) state = ADDR_PHONE; 
      else if(strcmp(str, "Mobile") == 0) state = ADDR_MOBILE; 
      else if(strcmp(str, "Email") == 0) state = ADDR_EMAIL; 
      else if(strcmp(str, "Etc") == 0) state = ADDR_ETC; 

      bzero(str, 256); 
      q = str;
      break;

    case ';':
      if(state == ADDR_NAME)        tmp->name   = strdup(str); 
      else if(state == ADDR_RUBY)   tmp->ruby   = strdup(str); 
      else if(state == ADDR_HOME)   tmp->home   = strdup(str); 
      else if(state == ADDR_PHONE)  tmp->phone  = strdup(str); 
      else if(state == ADDR_MOBILE) tmp->mobile = strdup(str); 
      else if(state == ADDR_EMAIL)  tmp->email  = strdup(str); 
      else if(state == ADDR_ETC)    tmp->etc    = strdup(str); 

      bzero(str, 256); 
      q = str;
      state = 0;
      break;

    case '\n':
    case '\t':
    case ' ':
      if(state == 0) break;

    case '\\':
      p++;
      if(*p == 'n') *q++ = '\n';
      else          *q++ = *p;
      break;

    default:
      *q++ = *p;
      break;
    }
    p++;
  }

  free(buf);

#else
  s = str;
  i = 0;
  while((c = fgetc(fp)) != EOF){
    switch(c){
    case '(': 
      i = 0;
      s = str;
      break;

    case ')':
      *s = '\0';
      if(i == 6){
	if(strlen(str) > 0) tmp->etc = strdup(str);
      }

      insert_person_data(tmp);
      i = 0;
      break;

    case '\n':
      break;

    case '\"':
      while( (c = fgetc(fp)) != EOF){
	if(c == '\"') break;
	*s++ = c;
      }
      break;

    case ' ':
      *s = '\0';

      if(s != str){
	switch(i){
	case 0:
	  tmp = create_person_data();
	  if(strlen(str) > 0) tmp->name = strdup(str);
	  break;
	case 1:
	  if(strlen(str) > 0) tmp->ruby = strdup(str);
	  break;
	case 2:
	  if(strlen(str) > 0) tmp->home = strdup(str);
	  break;
	case 3:
	  if(strlen(str) > 0) tmp->phone = strdup(str);
	  break;
	case 4:
	  if(strlen(str) > 0) tmp->mobile = strdup(str);
	  break;
	case 5:
	  if(strlen(str) > 0) tmp->email = strdup(str);
	  break;
	case 6:
	  if(strlen(str) > 0) tmp->etc = strdup(str);
	  break;
	}
      }
      i++;
      s = str;
      break;
      
    default:
      *s++ = c;
      break;
    }
  }
#endif

  fclose(fp);
}

struct person_data *
get_person_data(int num)
{
  return array[num];
}
